Imports System.Web.Services
Imports System.Configuration
Imports System.Data.SqlClient
Imports System.Messaging
Imports System.Xml
Imports System.Xml.Serialization
Imports System.IO
Imports System.TimeSpan
Imports System.Diagnostics

<System.Web.Services.WebService(Namespace:="http://tempuri.org/")> Public Class NavisionService
    Inherits System.Web.Services.WebService

#Region " Web Services Designer Generated Code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Web Services Designer.
        InitializeComponent()

        'Add your own initialization code after the InitializeComponent() call

    End Sub

    'Required by the Web Services Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Web Services Designer
    'It can be modified using the Web Services Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub

    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        'CODEGEN: This procedure is required by the Web Services Designer
        'Do not modify it using the code editor.
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

#End Region

    ' WEB SERVICE EXAMPLE
    ' The HelloWorld() example service returns the string Hello World.
    ' To build, uncomment the following lines then save and build the project.
    ' To test this web service, ensure that the .asmx file is the start page
    ' and press F5.
    '
    '<WebMethod()> Public Function HelloWorld() As String
    '	HelloWorld = "Hello World"
    ' End Function

    <WebMethod()> Public Function GetCompany() As Company
        Dim MyConnection As SqlConnection
        Dim MySQLCommand As String
        Dim MyCommand As SqlDataAdapter
        Dim Company As New Company()

        MyConnection = New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
        MySQLCommand = "SELECT Name FROM Company"
        MyCommand = New SqlDataAdapter(MySQLCommand, MyConnection)

        MyCommand.Fill(Company, "Company")

        Return Company
    End Function

    <WebMethod()> Public Function GetSalesDocument(ByVal CompanyName As String) As SalesDocument
        Dim MyConnection As SqlConnection
        Dim MySQLCommand As String
        Dim MyCommand As SqlDataAdapter
        Dim SalesDocument As New SalesDocument()

        MyConnection = New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
        MySQLCommand = "SELECT [Document Type], [No.] AS [Document No], [Sell-to Customer Name] FROM [" + CompanyName + "$Sales Header] WHERE ([Document Type] = 1)"
        MySQLCommand = NavisionWebService.NavisionNetFunction.ConvertCharacters(MySQLCommand)
        MyCommand = New SqlDataAdapter(MySQLCommand, MyConnection)

        MyCommand.Fill(SalesDocument, "Sales Header")

        Return SalesDocument
    End Function

    <WebMethod()> Public Function GetSalesDocumentDetail(ByVal CompanyName As String, ByVal DocumentType As Integer, ByVal DocumentNo As String) As SalesDocumentDetail
        Dim MyConnection As SqlConnection
        Dim MySQLCommand As String
        Dim MyCommand As SqlDataAdapter
        Dim SalesDocumentDetail As New SalesDocumentDetail()

        MyConnection = New SqlConnection(ConfigurationSettings.AppSettings("ConnectionString"))
        MySQLCommand = "SELECT [Document Type], [Document No.] AS [Document No], [Line No.] AS [Line No], [Description] FROM [" + CompanyName + "$Sales Line] WHERE ([Document Type] = " + Convert.ToString(DocumentType) + ") AND ([Document No.] =" + DocumentNo + ")"
        MySQLCommand = NavisionWebService.NavisionNetFunction.ConvertCharacters(MySQLCommand)
        MyCommand = New SqlDataAdapter(MySQLCommand, MyConnection)

        MyCommand.Fill(SalesDocumentDetail, "Sales Line")

        Return SalesDocumentDetail
    End Function

    <WebMethod()> Public Function RunNavisionProcess(ByVal CompanyName As String, ByVal FunctionName As String, ByVal ParameterList As String) As String
        Dim QueueToNavision As String = ".\private$\" + CompanyName + " 1"
        Dim QueueFromNavision As String = ".\private$\" + CompanyName + " 2"
        Dim MyNavisionObject1 As NavisionObject = New NavisionObject()
        Dim MyNavisionObject2 As NavisionObject = New NavisionObject()
        Dim MyNavisionErrorMsg As NavisionErrorMsg = New NavisionErrorMsg()
        Dim MyQueue1 As MessageQueue = New MessageQueue(QueueToNavision)
        Dim MyQueue2 As MessageQueue = New MessageQueue(QueueFromNavision)
        Dim MyMessage1 As Message
        Dim MyMessage2 As Message
        Dim MyFormatter = New XmlMessageFormatter(New Type() {GetType(NavisionErrorMsg)})
        If Not MyQueue2.Exists(QueueFromNavision) Then
            MyQueue2.Create(QueueFromNavision)
            MyQueue2.Label = QueueFromNavision
            MyQueue2.Authenticate = 0
            MyQueue2.MessageReadPropertyFilter.CorrelationId = True
            MyQueue2.UseJournalQueue = True
        End If
        If Not MyQueue1.Exists(QueueToNavision) Then
            MyQueue1.Create(QueueToNavision)
            MyQueue1.Label = QueueToNavision
            MyQueue1.Authenticate = 0
            MyQueue1.UseJournalQueue = True
        End If
        MyNavisionObject1.UserName = Me.User.Identity.Name()
        MyNavisionObject1.CompanyName = CompanyName
        MyNavisionObject1.FunctionName = FunctionName
        MyNavisionObject1.ParameterList = ParameterList
        MyMessage1 = New Message(MyNavisionObject1)
        MyMessage1.Label = "Navision MSMQ-BA"
        MyMessage1.ResponseQueue = MyQueue2
        MyQueue1.Send(MyMessage1)
        Try
            MyMessage2 = MyQueue2.PeekByCorrelationId(MyMessage1.Id, New TimeSpan(0, 1, 0))
        Catch
            Return "Error: Application Server Does Not Respond"
        End Try
        If MyFormatter.CanRead(MyMessage2) = True Then
            MyMessage2 = MyQueue2.ReceiveById(MyMessage2.Id)
            MyMessage2.Formatter = New XmlMessageFormatter(New Type() {GetType(NavisionErrorMsg)})
            MyNavisionErrorMsg = CType(MyMessage2.Body, NavisionErrorMsg)
            Return "Error: " + MyNavisionErrorMsg.ErrorMessage
        Else
            Return "Completed"
        End If
    End Function
End Class
